package org.gcube.informationsystem.resourceregistry.schema;

import java.util.List;

import org.gcube.informationsystem.model.reference.ERElement;
import org.gcube.informationsystem.resourceregistry.api.exceptions.ResourceRegistryException;
import org.gcube.informationsystem.resourceregistry.api.exceptions.schema.SchemaException;
import org.gcube.informationsystem.resourceregistry.api.exceptions.schema.SchemaNotFoundException;
import org.gcube.informationsystem.types.reference.Type;

/**
 * @author Luca Frosini (ISTI - CNR)
 */
public interface ResourceRegistrySchemaClient {

	public <ERElem extends ERElement> Type create(Class<ERElem> clz)
			throws SchemaException, ResourceRegistryException;
	
	public String create(String typeDefinitition)
			throws SchemaException, ResourceRegistryException;
	
	public <ERElem extends ERElement> List<Type> read(Class<ERElem> clz, Boolean polymorphic)
			throws SchemaNotFoundException, ResourceRegistryException;
	
	public String read(String typeName, Boolean polymorphic)
			throws SchemaNotFoundException, ResourceRegistryException;
	
}
